Subject: bug#45827: [aarch64] GCC 4.9.4 stack deallocation bug

From: Leo Famulari <[email-masked]>
Date: Tue, 12 Jan 2021 17:01:53 -0500

There was a bug in GCC 4.9.4 that could cause miscompilation, such that
the "compiler was freeing the function's stack frame prior to the end of
the function itself." [0]

The bug was observed to cause corruption of ext4 filesystems on the
aarch64 platform.

The upstream report is here:

https://gcc.gnu.org/bugzilla/show_bug.cgi?id=63293

Apparently this was fixed in GCC 5, but never backported to the 4.9
series.

Should we fix it? We use GCC 4.9 to bootstrap the system in (gnu
packages commencement), and a handful of packages depend on it.

[0]
https://lwn.net/SubscriberLink/842122/40442a015222c028/